#include "leastconn"

unsigned Leastconn::target(struct in_addr clientip,
			   BackendVector const &targetlist) {
    bool found = false;
    unsigned nconn, t;

    for (unsigned i = 0; i < targetlist.size(); i++) {
	if (! balancer.backend(targetlist[i]).available())
	    continue;
	unsigned weighted_conn =
	    balancer.backend(targetlist[i]).connections() *
	    balancer.backend(targetlist[i]).adjustedweight();
	if (config.verbose()) {
	    ostringstream o;
	    o << "connections "
	      << 	balancer.backend(targetlist[i]).connections()
	      << ", adjusted weight "
	      << balancer.backend(targetlist[i]).adjustedweight()
	      << ", weighted connections "
	      << weighted_conn;
	    msg ("Back end " + balancer.backend(targetlist[i]).description() +
		 ": " + o.str() + "\n");
	}
	
	if (!found || weighted_conn < nconn) {
	    t = targetlist[i];
	    nconn = balancer.backend(t).connections();
	    found = true;
	}
    }


    if (!found)
	throw static_cast<Error>
	    ("Least-connections algorithm: no available back ends");
    return (t);
}
