#include "tcpdispatcher"

void TcpDispatcher::execute() {
    ostringstream o;
    o << clientfd();
    msg ("Dispatch request for client fd " + o.str() + "\n");

    try {
	dispatch();
    } catch (Error const &e) {
	cerr << e.what() << "\n";
	socketclose (clientfd());
	return;
    }

    ostringstream co;
    co << clientfd();
    ostringstream bo;
    bo << backendfd();
    msg ("Dispatching client fd " + co.str() + " to " +
	 balancer.backend(target_backend).description() +
	 ", fd " + bo.str() + "\n");
    
    balancer.backend(target_backend).startconnection();

    try {
	handle();
    } catch (Error const &e) {
	cerr << e.what() << "\n";
    }

    balancer.backend(target_backend).endconnection();
    
    socketclose (clientfd());
    socketclose (backendfd());
    msg ("Done dispatching client fd " + co.str() + " at " +
	 balancer.backend(target_backend).description() + "\n");
	
}
