#include "tcpdispatcher"

void TcpDispatcher::handle() {
    if (config.debug()) {
	ostringstream o;
	o << "TCP dispatcher: About to shuttle between client fd "
	  << clientfd() << " and backend fd " << backendfd() << "\n";
	debugmsg (o.str());
    }
    
    while (1) {
	Fdset readset (config.client_timeout());
	readset.add (clientfd());
	readset.add (backendfd());
	
	int sock;
	if ((sock = readset.readable()) < 0)
	    break;

	if (config.debug()) {
	    ostringstream o;
	    o << sock;
	    debugmsg ("Data waiting on fd " + o.str() + "\n");
	}
	
	if (!readchunk (sock))
	    break;

	int othersock, timeout;
	if (sock == clientfd()) {
	    othersock = backendfd();
	    timeout = config.backend_timeout();
	} else {
	    othersock = clientfd();
	    timeout = config.client_timeout();
	}

	ostringstream o;
	o << "Had data on " << sock << ", sending to " << othersock << "\n";
	debugmsg (o.str());
	
	fdwrite (othersock, timeout, databuf(), databufsize());

	if (sock == backendfd())
	    balancer.backend(target_backend).addbytes(databufsize());
    }
}
