#include "webinterface"

void Webinterface::execute() {
    int sfd;

    // Create the server socket, or retry infinitely.
    while (true) {
	try {
	    msg ("Starting web interface\n");
	    sfd = serversocket (config.webinterfaceip(),
				config.webinterfaceport(),
				"web interface");
	} catch (Error const &e) {
	    cerr << e.what() << "(webinterface, retrying in a sec)\n";
	    sleep (1);
	    continue;
	}
	break;
    }
    
    ostringstream o;
    o << sfd;
    msg ("Web interface started on socket " + o.str() + "\n");

    while (!balancer.terminate()) {
	try {
	    Fdset fdset(0);
	    fdset.add (sfd);
	    if (fdset.readable() == sfd) {
		int size;
		struct sockaddr_in clname;
		if ( (cfd = accept (sfd, (struct sockaddr *) &clname,
				    (socklen_t *)&size)) > 0 )
		    serve ();
		socketclose(cfd);
	    }
	} catch (Error const &e) {
	    cerr <<  e.what() << " (webinterface)\n";
	    string err = static_cast<string>
	       ("HTTP/1.0 500 Server Error\r\n") +
		"X-Reason: " + e.what() + "\r\n"
		"Content-Length: 0\r\n"
		"\r\n";
	    try {
		fdwrite(cfd, config.client_timeout(), err.c_str(), err.size());
	    } catch (...) {
	    }
	    socketclose(cfd);
	}
    }
    msg ("Web interface stopping.\n");
    socketclose(sfd);
    shutdown (sfd, SHUT_RDWR);
}
