#include "webinterface"

void Webinterface::serve () {
    ostringstream o;
    o << cfd;
    msg ("Webinterface serving request on client fd " + o.str() + "\n");

    char databuf[config.buffersize()];
    Httpbuffer clientrequest;
    do {
	Fdset set (config.client_timeout());
	set.add(cfd);
	int nread;
	if (set.readable() != cfd ||
	    ( nread = read(cfd, databuf, config.buffersize()) ) < 0)
	    throw static_cast<Error>("Read failure on fd ") + cfd;
	clientrequest.add(databuf, nread);
    } while (clientrequest.bodyreceived() == Httpbuffer::b_is_not_received);
    msg ("Webinterface request: " + clientrequest.firstline() + "\n");

    answer(clientrequest);
}
